var b = Object.defineProperty;
var T = (e, t, r) => t in e ? b(e, t, { enumerable: !0, configurable: !0, writable: !0, value: r }) : e[t] = r;
var N = (e, t, r) => T(e, typeof t != "symbol" ? t + "" : t, r);
import { defineComponent, mergeModels, ref, computed, useModel, shallowRef, watch, openBlock, createElementBlock, toDisplayString, createCommentVNode, normalizeClass, unref, createVNode, normalizeStyle, createElementVNode, Fragment, renderList, withDirectives, vShow } from "vue";
import { javascript } from "@codemirror/lang-javascript";
import { oneDark } from "@codemirror/theme-one-dark";
import { pickedCompletion, closeBrackets, autocompletion } from "@codemirror/autocomplete";
import { Codemirror } from "vue-codemirror";
import { MatchDecorator, Decoration, ViewPlugin, EditorView, WidgetType } from "@codemirror/view";
import { mean, max, min, sum } from "lodash";
/**
 * formula-editor-vue3 - 0.0.1
 * (c) gkf442573575@163.com©2024
 * @license MIT
 */
class PlaceholderWidget extends WidgetType {
  constructor(r, i) {
    super();
    N(this, "name");
    N(this, "category");
    this.name = r, this.category = i;
  }
  eq(r) {
    return this.name == r.name && this.category == r.category;
  }
  toDOM() {
    const r = document.createElement("span");
    return r.className = `cm-widget-placeholder cm-widget-placeholder__${this.category}`, r.textContent = this.name, r;
  }
  ignoreEvent() {
    return !1;
  }
}
const createMathPlaceholder = (e, t, r) => {
  const i = new MatchDecorator({
    regexp: e,
    //支持中文
    decoration: (c) => {
      const l = t(c);
      return Decoration.replace({
        widget: new PlaceholderWidget(l, r || "widget")
      });
    }
  });
  return ViewPlugin.fromClass(
    class {
      constructor(c) {
        N(this, "placeholders");
        this.placeholders = i.createDeco(c);
      }
      update(c) {
        this.placeholders = i.updateDeco(c, this.placeholders);
      }
    },
    {
      decorations: (c) => c.placeholders,
      provide: (c) => EditorView.atomicRanges.of((l) => {
        var o;
        return ((o = l.plugin(c)) == null ? void 0 : o.placeholders) || Decoration.none;
      })
    }
  );
};
var MathKey = /* @__PURE__ */ ((e) => (e[e.ABS = 0] = "ABS", e[e.AVERAGE = 1] = "AVERAGE", e[e.FIXED = 2] = "FIXED", e[e.MAX = 3] = "MAX", e[e.MIN = 4] = "MIN", e[e.RAND = 5] = "RAND", e[e.SQRT = 6] = "SQRT", e[e.SUM = 7] = "SUM", e[e.LOWER = 8] = "LOWER", e[e.UPPER = 9] = "UPPER", e[e.REPEAT = 10] = "REPEAT", e[e.AND = 11] = "AND", e[e.IF = 12] = "IF", e[e.OR = 13] = "OR", e[e.NOT = 14] = "NOT", e))(MathKey || {});
const MATH_LIST = Object.keys(MathKey).filter((e) => isNaN(Number(e))), MATH_REG = new RegExp(MATH_LIST.join("|"), "g"), MATH_DESC_LIST = {
  ABS: {
    desc: "ABS函数可以获取一个数的绝对值",
    usage: "ABS(数字)",
    example: "ABS(-8) 可以返回8，也就是-8的绝对值"
  },
  AVERAGE: {
    desc: "AVERAGE函数可以获取一组数值的算术平均值",
    usage: "AVERAGE(数字1, 数字2, ...)",
    example: "AVERAGE(语文成绩, 数学成绩, 英语成绩) 返回三门课程的平均分"
  },
  FIXED: {
    desc: "FIXED函数可将数字舍入到指定的小数位数并输出为文本",
    usage: "FIXED(数字, 小数位数)",
    example: 'FIXED(3.1415, 2) 返回"3.14"'
  },
  MAX: {
    desc: "MAX函数可以获取一组数值的最大值",
    usage: "MAX(数字1, 数字2, ...)",
    example: "MAX(语文成绩, 数学成绩, 英语成绩) 返回三门课程中的最高分"
  },
  MIN: {
    desc: "MIN函数可以获取一组数值的最小值",
    usage: "MIN(数字1, 数字2, ...)",
    example: "MIN(语文成绩, 数学成绩, 英语成绩)返回三门课程中的最低分"
  },
  RAND: {
    desc: "RAND函数可返回大于等于0且小于1的均匀分布随机实数",
    usage: "RAND()",
    example: "RAND() 返回0.424656"
  },
  SQRT: {
    desc: "SQRT函数可以获取一个数字的正平方根",
    usage: "SQRT(数字)",
    example: "SQRT(9) 返回3，也就是9的正平方根"
  },
  SUM: {
    desc: "SUM函数可以获取一组数值的总和",
    usage: "SUM(数字1, 数字2, ...)",
    example: "SUM(语文成绩, 数学成绩, 英语成绩) 返回三门课程的总分"
  },
  LOWER: {
    desc: "LOWER函数可以将一个文本中的所有大写字母转换为小写字母",
    usage: "LOWER(文本)",
    example: 'LOWER("QWER") 返回"qwer"'
  },
  UPPER: {
    desc: "UPPER函数可以将一个文本中的所有小写字母转换为大写字母",
    usage: "UPPER(文本)",
    example: 'UPPER("qwer") 返回"QWER"'
  },
  REPEAT: {
    desc: "REPT函数可以将文本重复一定次数",
    usage: "REPT(文本, 重复次数)",
    example: 'REPT("云服务", 3) 返回"云服务云服务云服务"'
  },
  AND: {
    desc: "如果所有参数都为真，AND 函数返回布尔值 true，否则返回布尔值 false",
    usage: "AND(逻辑表达式1, 逻辑表达式2, ...)",
    example: "AND(语文成绩>90, 数学成绩>90, 英语成绩>90)，如果三门课成绩都> 90，返回true，否则返回false"
  },
  IF: {
    desc: "IF函数判断一个条件能否满足；如果满足返回一个值，如果不满足则返回另外一个值",
    usage: "IF(逻辑表达式, 为true时返回的值, 为false时返回的值)",
    example: 'IF(语文成绩>60, "及格", "不及格")，当语文成绩>60时返回及格，否则返回不及格。'
  },
  OR: {
    desc: "如果任意参数为真，OR 函数返回布尔值 true；如果所有参数为假，返回布尔值 false。",
    usage: "OR(逻辑表达式1, 逻辑表达式2, ...)",
    example: "OR(语文成绩>90, 数学成绩>90, 英语成绩>90)，任何一门课成绩>90，返回true，否则返回false"
  },
  NOT: {
    desc: "NOT函数返回与指定表达式相反的布尔值。",
    usage: "NOT(逻辑表达式)",
    example: "NOT(语文成绩>60)，如果语文成绩大于60返回false，否则返回true"
  }
}, FORMULA_MATHS = {
  ABS: (e) => isNaN(Number(e)) ? "" : Math.abs(e),
  AVERAGE: (...e) => mean(e.map((r) => isNaN(Number(r)) ? 0 : Number(r))) || "",
  FIXED: (e, t) => isNaN(Number(e)) ? "" : parseFloat(e).toFixed(t || 0),
  MAX: (...e) => max(e.map((r) => isNaN(Number(r)) ? 0 : Number(r))) || "",
  MIN: (...e) => min(e.map((r) => isNaN(Number(r)) ? 0 : Number(r))) || "",
  RAND: () => Math.random(),
  SQRT: (e) => isNaN(Number(e)) ? "" : Math.sqrt(e),
  SUM: (...e) => sum(e.map((r) => isNaN(Number(r)) ? 0 : Number(r))) || "",
  LOWER: (e) => e && typeof e == "string" ? e.toLowerCase() : "",
  UPPER: (e) => e && typeof e == "string" ? e.toUpperCase() : "",
  REPEAT: (e, t) => (t = isNaN(parseInt(t)) ? 0 : Math.abs(parseInt(t)), e && typeof e == "string" ? e.repeat(t) : ""),
  AND: (...e) => e.every((t) => !!t),
  OR: (...e) => e.some((t) => !!t),
  IF: (e, t, r) => e ? t ?? "" : r ?? "",
  NOT: (e) => !e
}, uuid = () => "xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g, function(e) {
  var t = Math.random() * 16 | 0, r = e == "x" ? t : t & 3 | 8;
  return r.toString(16);
}), isStrBrackets = (e) => /[\'\"]{1}/.test(e), VARIABLE_REG = /\$\{(.*?)\}/g, isCloseBrackets = (e) => {
  const t = [
    ["{", "}"],
    ["[", "]"],
    ["(", ")"]
  ], r = e.split("");
  if (!r.length)
    return !0;
  const i = {}, p = [], c = [];
  for (let o = 0; o < t.length; o++) {
    const [m, u] = t[o];
    i[m] = o + 1, i[u] = -(o + 1), p.push(m), c.push(u);
  }
  const l = [];
  for (let o = 0; o < r.length; o++) {
    const m = r[o], u = i[m];
    if (u && !(o > 0 && isStrBrackets(r[o - 1]) && isStrBrackets(r[o + 1]))) {
      if (p.includes(m))
        l.push(u);
      else if (c.includes(m)) {
        const h = l.length;
        h > 0 && l[h - 1] + u === 0 ? l.pop() : l.push(u);
      }
    }
  }
  return l.length === 0;
}, evalFormula = (formula, variableHandler, formulaSope) => {
  const isPass = isCloseBrackets(formula);
  if (!isPass)
    throw new Error("括号不匹配");
  try {
    console.log(formulaSope && formulaSope[uuid()]);
    let evalFormula = formula.replace(VARIABLE_REG, (e, t) => "formulaSope" + variableHandler(t));
    evalFormula = evalFormula.replace(MATH_REG, (e) => `FORMULA_MATHS['${e}']`);
    const result = eval(evalFormula);
    return result;
  } catch (e) {
    throw e;
  }
}, _hoisted_1 = { class: "formula-editor" }, _hoisted_2 = {
  key: 0,
  class: "formula-editor-title"
}, _hoisted_3 = { class: "formula-params" }, _hoisted_4 = { class: "formula-params-variable formula-params-list" }, _hoisted_5 = ["onClick"], _hoisted_6 = { class: "variable-item-label" }, _hoisted_7 = { class: "formula-params-maths formula-params-list" }, _hoisted_8 = ["onClick", "onMouseenter"], _hoisted_9 = { class: "formula-maths-desc formula-params-list" }, _hoisted_10 = { class: "math-desc" }, _hoisted_11 = { class: "math-usage" }, _hoisted_12 = { class: "math-example" }, _sfc_main = /* @__PURE__ */ defineComponent({
  name: "FormulaEditor",
  __name: "index",
  props: /* @__PURE__ */ mergeModels({
    title: {
      type: String,
      default: ""
    },
    isDark: {
      type: Boolean,
      default: !1
    },
    disabled: {
      type: Boolean,
      default: !1
    },
    variables: {
      type: Array,
      default: () => []
    },
    height: {
      type: Number,
      default: 200
    },
    placeholder: {
      type: String,
      default: ""
    }
  }, {
    modelValue: { default: "" },
    modelModifiers: {}
  }),
  emits: ["update:modelValue"],
  setup(e) {
    const t = e, r = uuid(), i = ref(0), p = computed(() => t.variables.map((a) => a.value)), c = useModel(e, "modelValue"), l = shallowRef(), o = ref("ABS"), m = createMathPlaceholder(
      VARIABLE_REG,
      (a) => {
        const n = a[1], s = t.variables.find((d) => d.value === n);
        return s && s.label || "不可用字段";
      },
      "variable"
    ), u = createMathPlaceholder(
      MATH_REG,
      (a) => a[0],
      "mathfunc"
    ), h = MATH_LIST.map((a) => ({
      label: a,
      type: "keyword",
      apply: (n, s, d, g) => {
        var f;
        n.dispatch({
          changes: {
            from: d,
            to: g,
            insert: `${s.label}()`
          }
        });
        let E = ((f = l.value) == null ? void 0 : f.state.selection.main.head) || 0;
        n.dispatch({
          selection: { anchor: E - 1 },
          annotations: pickedCompletion.of(s)
        });
      }
    })), R = (a) => {
      let n = a.matchBefore(/\w+/);
      return !a.explicit && !n ? null : {
        from: n ? n.from : a.pos,
        options: [...h],
        validFor: /^\w*$/
      };
    }, v = computed(() => {
      const a = [
        javascript(),
        closeBrackets(),
        autocompletion({ override: [R] }),
        m,
        u
      ];
      return t.isDark && a.push(oneDark), a;
    }), A = (a, n, s = !1) => {
      if (!l.value)
        return;
      const { from: d, to: g } = l.value.state.selection.main, E = n(a), f = E.length;
      l.value.dispatch({
        changes: {
          from: d,
          to: g,
          insert: E
        },
        selection: {
          anchor: d + (s ? f - 1 : f)
        }
      }), l.value.focus();
    }, x = (a) => {
      A(a.value, (n) => "${" + n + "}");
    }, _ = (a) => {
      A(a, (n) => `${n}()`, !0);
    }, S = (a) => {
      l.value = a.view;
    };
    return watch(
      () => p.value,
      () => {
        i.value++;
      },
      {
        deep: !0,
        immediate: !0
      }
    ), (a, n) => (openBlock(), createElementBlock("div", _hoisted_1, [
      e.title ? (openBlock(), createElementBlock("div", _hoisted_2, toDisplayString(e.title) + " =", 1)) : createCommentVNode("", !0),
      (openBlock(), createElementBlock("div", {
        class: normalizeClass(["formula-editor-container", { hasTitle: e.title }]),
        key: `${unref(r)}_${i.value}`
      }, [
        createVNode(unref(Codemirror), {
          modelValue: c.value,
          "onUpdate:modelValue": n[0] || (n[0] = (s) => c.value = s),
          class: "formula-editor-codemirror",
          style: normalizeStyle({ height: `${e.height}px`, minHeight: "200px" }),
          autofocus: !0,
          "indent-with-tab": !0,
          "tab-size": 2,
          extensions: v.value,
          disabled: e.disabled,
          placeholder: e.placeholder || "请输入...",
          onReady: S
        }, null, 8, ["modelValue", "style", "extensions", "disabled", "placeholder"])
      ], 2)),
      createElementVNode("div", _hoisted_3, [
        createElementVNode("ul", _hoisted_4, [
          (openBlock(!0), createElementBlock(Fragment, null, renderList(e.variables, (s) => (openBlock(), createElementBlock("li", {
            class: "variable-item formula-params-item",
            key: s.value,
            onClick: (d) => x(s)
          }, [
            createElementVNode("span", _hoisted_6, toDisplayString(s.label), 1),
            withDirectives(createElementVNode("span", { class: "variable-item-desc" }, toDisplayString(s.desc), 513), [
              [vShow, s.desc]
            ])
          ], 8, _hoisted_5))), 128))
        ]),
        createElementVNode("ul", _hoisted_7, [
          (openBlock(!0), createElementBlock(Fragment, null, renderList(unref(MATH_LIST), (s) => (openBlock(), createElementBlock("li", {
            class: "maths-item formula-params-item",
            key: s,
            onClick: (d) => _(s),
            onMouseenter: (d) => o.value = s
          }, toDisplayString(s), 41, _hoisted_8))), 128))
        ]),
        createElementVNode("div", _hoisted_9, [
          createElementVNode("p", _hoisted_10, toDisplayString(unref(MATH_DESC_LIST)[o.value].desc), 1),
          createElementVNode("p", _hoisted_11, "用法：" + toDisplayString(unref(MATH_DESC_LIST)[o.value].usage), 1),
          createElementVNode("p", _hoisted_12, "示例：" + toDisplayString(unref(MATH_DESC_LIST)[o.value].example), 1)
        ])
      ])
    ]));
  }
});
window.FORMULA_MATHS = FORMULA_MATHS;
const index = {
  install(e) {
    e.component(_sfc_main.name || "FormulaEditor", _sfc_main);
  }
};
export {
  index as default,
  evalFormula,
  isCloseBrackets
};
