export declare enum MathKey {
    ABS = 0,
    AVERAGE = 1,
    FIXED = 2,
    MAX = 3,
    MIN = 4,
    RAND = 5,
    SQRT = 6,
    SUM = 7,
    LOWER = 8,
    UPPER = 9,
    REPEAT = 10,
    AND = 11,
    IF = 12,
    OR = 13,
    NOT = 14
}
export type MathName = keyof typeof MathKey;
export declare const MATH_LIST: ("ABS" | "AVERAGE" | "FIXED" | "MAX" | "MIN" | "RAND" | "SQRT" | "SUM" | "LOWER" | "UPPER" | "REPEAT" | "AND" | "IF" | "OR" | "NOT")[];
export declare const MATH_REG: RegExp;
export declare const MATH_DESC_LIST: Record<MathName, {
    desc: string;
    usage: string;
    example: string;
}>;
/**
 * @desc 进行公式计算的方法
 */
export declare const FORMULA_MATHS: Record<MathName, (...arg: any[]) => boolean | number | string>;
export type FORMULA_MATHS_TYPE = typeof FORMULA_MATHS;
